#!usr/bin/python
# -*- coding: UTF-8 -*-
# @Time    : 2020/03/20
# @Author  : 张晓平
import time, os, sys

sys.path.append(os.path.split(os.path.abspath(os.path.dirname(__file__)))[0])
from original_data.file_io import FileIo


class DataGeneration(FileIo):
    """
    这边区分接口跟用例的意义是同一个接口有多个用例
    """

    def add_interface(self, interface_name, cases_name, file_path,**kwargs):
        """
        读取当前接口,然后判断新增后保存成新的文件
        :return:
        """
        interface_num = 0
        case_num = 0
        # 判断是否有数据,没有就读取默认模版数据
        exists = os.path.exists(self.test_file_path)
        if exists is True:
            data = self.file_r_test()
            interface_num = len(data['details'])
            data['details'].append({})
            data['details'][interface_num] = {}
            data['details'][interface_num]['records'] = []
            case_num = len(data['details'][interface_num]['records']) - 1
            data['details'][interface_num]['records'].append({})
            data['details'][interface_num]['records'][case_num]['meta_data'] = {}
            data['details'][interface_num]['records'][case_num]['meta_data']['request'] = {}
            data['details'][interface_num]['records'][case_num]['meta_data']['response'] = {}
        else:
            data = self.file_r()

        # 报告基础信息
        data['details'][interface_num]['success'] = kwargs['case_result']  # 判断接口是否成功  不填默认fail
        data['time']['start_at'] = time.time()  # 时间戳 没有传报告名 就默认以此命名
        data['html_report_name'] = self.current_time  # 报告名称
        data['details'][interface_num]['time'] = {  # 用例生成时间
            "duration": 0.8010456562042236,  # 运行时间
            "start_at": self.current_time
        }
        # 接口数据
        data['details'][interface_num]['base_url'] = kwargs['url']  # 请求地址
        data['details'][interface_num]['name'] = interface_name  # 接口名称
        data['details'][interface_num]['records'][case_num]['name'] = cases_name  # 用例名称
        for key in kwargs:
            if key != 'headers':
                data['details'][interface_num]['records'][case_num]['meta_data']['request']['headers'] = {}
            else:
                data['details'][interface_num]['records'][case_num]['meta_data']['request']['headers'] = kwargs[
                    'headers']
            if key != 'response_headers':
                data['details'][interface_num]['records'][case_num]['meta_data']['response']['headers'] = {}
            else:
                data['details'][interface_num]['records'][case_num]['meta_data']['response']['headers'] = kwargs[
                    'response_headers']
        # 请求参数
        data['details'][interface_num]['records'][case_num]['meta_data']['request']['request_data'] = kwargs[
            'request_data']
        data['details'][interface_num]['records'][case_num]['meta_data']['request']['method'] = "post"  # 请求方式
        data['details'][interface_num]['records'][case_num]['meta_data']['request']['url'] = kwargs['url']  # 用例路径
        # 返回值
        # data['details'][interface_num]['records'][case_num]['meta_data']['response']['cookies']={}
        data['details'][interface_num]['records'][case_num]['meta_data']['response']['response_data'] = kwargs[
            'response_data']
        # 接口统计信息
        if kwargs['case_result'] is False:
            data['success'] = False
            data['details'][interface_num]['records'][case_num]['status'] = "error"
        else:
            data['details'][interface_num]['records'][case_num]['status'] = "success"  # 不可缺失 根据status 判断生成页签信息
            data['success'] = True
        data['details'][interface_num]['stat'] = {'testsRun': case_num + 1,
                                                  'failures': 0,
                                                  'errors': 0, 'skipped': 0,
                                                  'expectedFailures': 0,
                                                  'unexpectedSuccesses': 0,
                                                  'successes': 2}
        data['stat']['failures'] = 0  # 失败用例
        data['stat']['successes'] = 2  # 成功用例
        data['stat']['testsRun'] = case_num + 1  # 运行用例数
        data['stat']['skipped'] = 0  # 跳过用例数
        # 保存数据  这部分可以用其他语言实现生产yaml 文件 这边是提供一个跨平台实现的一个思路
        self.file_w_test(data,file_path)

    def add_cases(self, interface_name, cases_name, file_path,**kwargs):
        """
        需要指定接口接口下添加用例 接口名称需要与添加的一致
        :param interface_name: 接口名称
        :param cases_name: 用例名称
        :param kwargs:
        :return:
        """
        interface_num = 0
        case_num = 0
        interface_list = []
        # 判断是否有数据,没有就读取默认模版数据
        exists = os.path.exists(self.test_file_path)
        if exists is True:
            data = self.file_r_test()

            # 通过接口名称在接口下添加用例
            num = 0
            while num < len(data['details']):
                if interface_name == data['details'][num]['name']:
                    interface_list.append(data['details'][num]['name'])
                    interface_num = num
                    break
                num += 1
            if interface_name not in interface_list:
                print(interface_name, "创建报告失败,当前接口未创建,请先创建接口名称后再添加用例")
                return
            case_num = len(data['details'][interface_num]['records'])
            data['details'][interface_num]['records'].append({})
            data['details'][interface_num]['records'][case_num]['meta_data'] = {}
            data['details'][interface_num]['records'][case_num]['meta_data']['request'] = {}
            data['details'][interface_num]['records'][case_num]['meta_data']['response'] = {}
        else:
            data = self.file_r()

        for key in kwargs:
            if key != 'headers':
                data['details'][interface_num]['records'][case_num]['meta_data']['request']['headers'] = {}
            else:
                data['details'][interface_num]['records'][case_num]['meta_data']['request']['headers'] = kwargs[
                    'headers']
            if key != 'response_headers':
                data['details'][interface_num]['records'][case_num]['meta_data']['response']['headers'] = {}
            else:
                data['details'][interface_num]['records'][case_num]['meta_data']['response']['headers'] = kwargs[
                    'response_headers']
        # 基础信息
        data['details'][interface_num]['base_url'] = kwargs['url']  # 请求地址
        data['details'][interface_num]['name'] = interface_name  # 接口名称
        data['details'][interface_num]['success'] = kwargs['case_result']  # 判断接口是否成功  不填默认fail
        data['time']['start_at'] = time.time()  # 时间戳 没有传报告名 就默认以此命名
        data['html_report_name'] = self.current_time  # 报告名称
        data['details'][interface_num]['time'] = {  # 用例生成时间
            "duration": 0.8010456562042236,  # 运行时间
            "start_at": self.current_time
        }
        # 用例信息
        data['details'][interface_num]['records'][case_num]['name'] = cases_name
        data['details'][interface_num]['records'][case_num]['success'] = kwargs['case_result']  # 判断接口是否成功  bool
        if kwargs['case_result'] is False:
            data['success'] = False
            data['details'][interface_num]['records'][case_num]['status'] = "error"
        else:
            data['details'][interface_num]['records'][case_num]['status'] = "success"  # 不可缺失 根据status 判断生成页签信息
            data['success'] = True
        data['details'][interface_num]['records'][case_num]['meta_data']['request'][
            'start_timestamp'] = self.current_time
        data['details'][interface_num]['records'][case_num]['meta_data']['request']['request_data'] = kwargs[
            'request_data']
        data['details'][interface_num]['records'][case_num]['meta_data']['request']['method'] = "post"  # 请求方式
        data['details'][interface_num]['records'][case_num]['meta_data']['request']['url'] = kwargs['url']  # 用例地址
        # data['details'][interface_num]]['records'][case_num]['meta_data']['response']['cookies']={}
        # 返回值
        data['details'][interface_num]['records'][case_num]['meta_data']['response']['response_data'] = kwargs[
            'response_data']
        # 统计信息
        data['details'][interface_num]['stat'] = {'testsRun': case_num + 1,
                                                  'failures': 0,
                                                  'errors': 0, 'skipped': 0,
                                                  'expectedFailures': 0,
                                                  'unexpectedSuccesses': 0,
                                                  'successes': case_num + 1
                                                  }
        data['stat']['failures'] = 1  # 失败用例
        data['stat']['successes'] = 0  # 成功用例
        data['stat']['testsRun'] = case_num + 1  # 运行用例数
        data['stat']['skipped'] = 0  # 跳过用例数
        # 保存数据
        self.file_w_test(data,file_path)
